
//
// Copyright 2010, Lowell Boggs Jr.
//
// This file or directory, containing source code for a computer program,
// is Copyrighted by Lowell Boggs, Jr.  987 Regency Drive, Lewisville
// TX (USA), 75067.  You may use, copy, modify, and distribute this
// source file without charge or obligation so long as you agree to
// the following:
//
//  1.  You must indemnify Lowell Boggs against any and all financial
//      obligations caused by its use, misuse, function, or malfunction.
//      Further, you acknowledge that there is no warranty of any kind,
//      whatsoever.
//
//  2.  You agree not to attempt to patent any portion of this original
//      work -- though you may attempt to patent your own extensions to
//      it if you so choose.
//
//  3.  You keep this copyright notice with the file and all copies
//      of the file and do not change it anyway except language translation.
//
// You are responsible for enforcing your own compliance with these
// conditions and may not use this source file if you cannot agree to the
// above terms and conditions.


//@File
//
///   This file defines a test for the Viewer class by creating a
///   trivial application that creates a single viewer.

#include <cxxtls/tableviewer.h>
#include <cxxtls/viewermanager.h>
#include <iostream>

using namespace std;
using namespace cxxtls;



int main()
{
  ViewerManager vm;

  vm.open();

  TableViewer *p;

  vm.add( p = (new TableViewer(&vm)), "table" );

  p->setRowsAndColumns(200,200);

  for(int i = 0; i < 200; ++i)
  {
    char buffer[40];

    sprintf(buffer, "%d", i);

    if(i % 5 == 0 && i)
    {
        p->setRowInfo(i, buffer, 4, true);
    }
    else
        p->setRowInfo(i, buffer, 4, false);


    p->setColInfo(i, buffer, 4, false);
  }

  for(int row=0; row < 200;  ++row)
    for(int col=0; col < 200; ++col)
    {
       TableViewer::CellInfo *cellInfo = p->cellInfo(row,col);

       if(cellInfo == 0)
          abort();  // program bug

       char buffer[80];

       sprintf(buffer, "%03dx,%03dy", row, col);

       if(cellInfo->text_.size() == 0)
          cellInfo->text_.push_back(buffer);
       else
          cellInfo->text_[0] = buffer;

    }

  p->setOrigin(0,0); // virtual world top left corner


  (*p)(vm.active_viewport(), CursorWindow::viewport::repaint_handler::activate);

  vm.run();



}

