#include <iostream>
#include <cxxtls/getopt.h>
#include <stdlib.h>
#include <iomanip>

using namespace std;


int main(int argc, char **argv)
{
    cout << "GetOpts Test Begins" << endl;


    GetOpts  optProc;

    {
      int aflag = 0;
      int bflag = 0;
      char *cvalue = NULL;
      int index;
      int c;
    
      optProc.opterr = 0;
      while ((c = optProc.getopt (argc, argv, "abc:")) != -1)
        switch (c)
          {
          case 'a':
            aflag = 1;
            break;
          case 'b':
            bflag = 1;
            break;
          case 'c':
            cvalue = optProc.optarg;
            break;
          case '?':
            if (optProc.optopt == 'c')
              cout << "Option -" << char(optProc.optopt) << " requires an argument." << endl;
            else if (isprint (optProc.optopt))
              cout << "Unknown option `-" << char(optProc.optopt) << "'" << endl;
            else
              cout << "Unknown option character `\\x" << std::hex << optProc.optopt << std::dec << "%x'" << endl;

            cout << "GetOpts Test FAILED\n" << endl;
            return 1;

          default:
              cout << "Huh?  How did we get an illegal return code from getopt()?" << endl;
              cout << "GetOpts Test FAILED\n" << endl;
              exit(1);
          }


      cout << "a flag = " << aflag << ", b flag = " << bflag << ", c value = " << (cvalue ? cvalue : "''") << endl;
           
    
      for (index = optProc.optind; index < argc; index++)
        cout << "Non-option argument: " << argv[index] << endl;

    }




    cout << "GetOpts Test Ends" << endl;

    cout << endl;
    cout << endl;
}
