#!/bin/bash

#
#  This script assumes that i's current directory is not ., but .. (ie it's parent)
#


#set -x

testname="$1"
testscript="$2"
testinput="$3"

mused.exe $testscript $testinput >tests/$testname.out

if grep -q '^ *W' $testscript 
then
    rm -f tests/$testname.sed.output
else
    
    sed -n -e '/^ *output data\[/{
				    s/^[^=]*=//1
				    p
				 }
	      ' tests/$testname.out >tests/$testname.sed.comparand
    
    sed -n -f $testscript $testinput >tests/$testname.sed.output

fi

diff tests/$testname.expect   tests/$testname.out   >tests/$testname.diff

if [ -s tests/$testname.diff -o ! -r tests/$testname.expect ] 
then 
    echo muSED TEST $testname FAILED -- SEE tests/$testname.diff
else 

    if [ -r tests/$testname.sed.output ]
    then
	if ! diff tests/$testname.sed.output tests/$testname.sed.comparand >tests/$testname.sed.diff
	then
	   echo muSED TEST $testname FAILED:  did not match sed output, see tests/$testname.sed.diff
	   exit 1
	fi
    fi

    rm -f tests/$testname.diff tests/$testname.sed.*
    echo muSED TEST $testname PASSED
fi


exit 0
