#include <cxxtls\scriptthread.h>
#include <stdlib.h>

#ifdef _MSC_VER
#include <windows.h>
#endif

using namespace std;
using namespace cxxtls;
using namespace ScriptThread;

int main(int argc, char **argv)
{
   ++argv;
   --argc;


   bool clone=false;

   if(*argv && *argv == string("-clone"))
   {
       ++argv;
       --argc;

       clone=true;

   }

   ManagedFileHandles::IO_ERROR err;

   StringExpr::ExecutionVariables env;

   env.includeProgramEnvironment();

   env.set("FLARN","TARG");

   if(argc)
   {
      while(*argv)
      {
          string name(*argv++);
          
          cout << name << "=" << env.get(name) << endl;
      }
   }
   else
   {
       ManagedFileHandles* handles = ManagedFileHandles::mainStdHandles;

       if(clone)
       {
           handles->clone();

           if(!handles)
           {
               cerr << "Error:  cannot clone the standard handles" << endl;
               exit(1);
           }
           else
           {
              err = handles->writeBytes(1, "Cloned Handle Contents:\n");

              if(err)
              {
                  cerr << "Error writing to cloned handle" << endl;
              }
           }
       }


#ifdef _MSC_VER
       handles->callProcess("CMD /C SET", env);
#else
       handles->callProcess("bash -c env", env);
#endif
   }
}
