
//
// Copyright 2002, Lowell Boggs Jr.
//
// This file or directory, containing source code for a computer program,
// is Copyrighted by Lowell Boggs, Jr.  987 Regency Drive, Lewisville
// TX (USA), 75067.  You may use, copy, modify, and distribute this
// source file without charge or obligation so long as you agree to
// the following:
//
//  1.  You must indemnify Lowell Boggs against any and all financial
//      obligations caused by its use, misuse, function, or malfunction.
//      Further, you acknowledge that there is no warranty of any kind,
//      whatsoever.
//
//  2.  You agree not to attempt to patent any portion of this original
//      work -- though you may attempt to patent your own extensions to
//      it if you so choose.
//
//  3.  You keep this copyright notice with the file and all copies
//      of the file and do not change it anyway except language translation.
//
// You are responsible for enforcing your own compliance with these
// conditions and may not use this source file if you cannot agree to the
// above terms and conditions.



#include <cxxtls/cursorwindow.h>
#include <stdlib.h>

using namespace std;

using namespace cxxtls;

  class Background
  : public CursorWindow::viewport::repaint_handler
  {
  public:

    void operator() (CursorWindow::viewport *v, int cmd)
    {
      v->set_curpos(0,0);
      v->fill_to_eos('-');
    }
  };


int main()
{
  CursorWindow cw;


  cw.open();

  Background bh;

  std::auto_ptr<CursorWindow::viewport> background(cw.new_viewport(&bh).release());

  bh(background.get(),0);

  {

    CursorWindow::Dialog dialog("A Wide Dialog Window");

    dialog += new CursorWindow::Dialog::Ok("ok1", "Press return 1");
    dialog += new CursorWindow::Dialog::Ok("ok2", "Press return 2                       333333333333333333333333333333333333333333332");
    dialog += new CursorWindow::Dialog::Ok("ok3", "3");

    dialog.popup(background->window());

  }

  {

    CursorWindow::Dialog dialog("A Tall Dialog Window");

    dialog += new CursorWindow::Dialog::Ok("ok1", "Press return 1");
    dialog += new CursorWindow::Dialog::Ok("ok2", "Press return 2");
    dialog += new CursorWindow::Dialog::Ok("ok3", "3");
    dialog += new CursorWindow::Dialog::Ok("ok4", "4");
    dialog += new CursorWindow::Dialog::Ok("ok5", "5");
    dialog += new CursorWindow::Dialog::Ok("ok6", "6");
    dialog += new CursorWindow::Dialog::Ok("ok7", "7");
    dialog += new CursorWindow::Dialog::Ok("ok8", "8");
    dialog += new CursorWindow::Dialog::Ok("ok9", "9");
    dialog += new CursorWindow::Dialog::Ok("ok10","10");

    dialog.popup(background->window());

  }

  {

    CursorWindow::Dialog dialog("String test dialog");

    dialog += new CursorWindow::Dialog::String("field",
					       "label",
					       "default value",
					       15
					      );

    dialog += new CursorWindow::Dialog::Ok("ok","");

    dialog.popup(background->window());

  }

  {

    CursorWindow::Dialog dialog("Password test dialog");

    dialog += new CursorWindow::Dialog::Password("field",
					       "label",
					       "default value",
					       15
					      );

    dialog += new CursorWindow::Dialog::Ok("ok","");

    dialog.popup(background->window());

  }

  {
    CursorWindow::Selection selection("pick one of the following");

    selection += "line one";
    selection += "line two";
    selection += "line three";
    selection += "line four";
    selection += "line five";

    selection.popup(background->window());


  }



}
