#include <cxxtls/file.h>
#include <stdlib.h>
#include <portable_io.h>
#include <string.h>
#include <errno.h>

using namespace std;
using namespace cxxtls;

int main(int argc, char **argv)
{
  if(argc < 3)
  {
    fprintf(stderr, "Error:  insufficent parameters\n");
    exit(1);
  }

  FileName infile(argv[1]);
  FileName outfile(argv[2]);


  std::list<std::string> lines;

  std::string read_error = infile.read_file(lines);

  if(read_error != "")
  {
    fprintf(stderr, "Error:  read error, %s\n", read_error.c_str());
    exit(1);
  }

  FILE* f = fopen(outfile.c_str(), "wb");

  if(!f)
  {
      fprintf(stderr,
	      "Error:  error opening %s, %s\n",
	      outfile.c_str(),
	      strerror(errno)
	     );
      exit(1);
  }

  std::list<std::string>::iterator first = lines.begin(),
				   last	 = lines.end();
					
  while(first != last)
  {
    std::string line = *first++;

    if(fwrite(line.data(), 1, line.size(), f) != line.size())
    {
      fprintf(stderr, "Error:  write error, %s\n", strerror(errno) );
      exit(1);
    }

    fwrite("\n", 1, 1, f);

  }

  if(fclose(f))
  {
    fprintf(stderr, "Error:  write error, %s\n", strerror(errno) );
    exit(1);
  }

  exit(0);
}
