#include <fmtio/fmtio.h>
#include <stdlib.h>



using namespace std;

// turn on where to get line number information, but turn it off because tests fail with it on wevery
// time you edit this file.

#if 0
#     define WHERE cout << __FILE__ << ":" << __LINE__ 
#else
#     define WHERE cout 
#endif


#define OUTPUT(x,ctls) WHERE << " variable " << setw(16) << #x << ' ' << fmtio::cs(ctls) % (x) << endl

struct user 
{ 
  user()
  {
  }
};

ostream &operator << (ostream &s, user const &u)
{
  return s << "u";
}

enum constants { enum1 };

int main()
try
{
   cout << "prefix: " << fmtio::cs("abc[%08d]efg<%-8x>hij") % 9 % 10<< endl;

   
   int            i_int   = 1;
   char           c_char  = 'c';
   short          i_short = 1;
   long           i_long  = 1;
   long long      i_ll    = 1;
   unsigned       i_uint  = 1;
   unsigned       char c_uchar = 'c';
   char const    *s_char     = "ss";
   unsigned char *s_uchar = (unsigned char *)("ss");
   char          *z_char = (char*)("zz");
   string         s_string("ss");
   float          f_float = 1;
   double         f_double= 1;
   user           u_user;
   long          *p_long = 0;
   long           a_long[40];
   constants      e_enum1 = enum1;
//
   const int            Ki_int   = 1;
   const char           Kc_char  = 'c';
   const short          Ki_short = 1;
   const long           Ki_long  = 1;
   const long long      Ki_ll    = 1;
   const unsigned       Ki_uint  = 1;
   const unsigned char  Kc_uchar = 'c';
   const char          *Ks_char     = "ss";
   const unsigned char *Ks_uchar = (unsigned char *)("ss");
   const char          *Kz_char = (char*)("zz");
   const string         Ks_string("ss");
   const float          Kf_float = 1;
   const double         Kf_double= 1;
   const user           Ku_user;
   const long          *Kp_long = 0;
   const long           Ka_long[2]={1,2};
   const constants      Ke_enum1 = enum1;


   OUTPUT(i_int, "%d");
   OUTPUT(c_char, "%c");
   OUTPUT(i_short, "%u");
   OUTPUT(i_long, "%x");
   OUTPUT(i_ll, "%o");
   OUTPUT(s_char, "%s");
   OUTPUT(z_char, "%s");
   OUTPUT(s_uchar, "%s");
   OUTPUT(s_string, "%s");
   OUTPUT(f_float, "%f");
   OUTPUT(f_double, "%f");
   OUTPUT(u_user, "%U");
   OUTPUT(i_uint, "%u");
   OUTPUT(c_uchar, "%c");
   OUTPUT(p_long, "%x");
   OUTPUT(i_int + c_char, "%d");
   OUTPUT(s_char + i_int, "%s");
   OUTPUT(e_enum1, "%d");
   OUTPUT(enum1, "%x");

   OUTPUT(Ki_int, "%d");
   OUTPUT(Kc_char, "%c");
   OUTPUT(Ki_short, "%u");
   OUTPUT(Ki_long, "%x");
   OUTPUT(Ki_ll, "%o");
   OUTPUT(Ks_char, "%s");
   OUTPUT(Kz_char, "%s");
   OUTPUT(Ks_uchar, "%s");
   OUTPUT(Ks_string, "%s");
   OUTPUT(Kf_float, "%f");
   OUTPUT(Kf_double, "%f");
   OUTPUT(Ku_user, "%U");
   OUTPUT(Ki_uint, "%u");
   OUTPUT(Kc_uchar, "%c");
   OUTPUT(Kp_long, "%x");
   OUTPUT(Ki_int + c_char, "%d");
   OUTPUT(Ks_char + i_int, "%s");
   OUTPUT(Ke_enum1, "%x");


   cout << "combination:  " << fmtio::cs("%s%d%d%d%d%d%s") %"[" %i_int  %i_short  %i_long  %i_long  %i_ll  %"]" << endl;

   cout << "multi: " << fmtio::cs("%d") % -3 << fmtio::cs("%s") % "string" << endl;

   cout << "flt:  [" << fmtio::cs("%-010.4f") % 1.123 << "][" << fmtio::cs("%010.4f") % 1.123 << "]" << endl;

   cout << "user: [" << fmtio::cs("%010U") % u_user << "] " << 19 << endl;

   string tmp = fmtio::cs("%010u") % 19;

   cout << "string converted:  " << tmp << endl;

   cout << "string expression: " << (string) (fmtio::cs("%-10u") % 37) << "crap" << endl;

   cout << "float expression:  " << fmtio::cs("%f") % ( 12.9 / 3.1 ) << endl;

   cout << "float expression:  " << fmtio::cs("%10.5f") % ( double(12.9) / double(3.1) ) << endl;

   cout << "array expression:  (expected to diff) " << fmtio::cs("%x") % a_long << endl;
   cout << "array expression:  (expected to diff) " << fmtio::cs("%x") % Ka_long << endl;
   cout << "array expression:  (expected to diff) " << fmtio::cs("%x") % (a_long + i_int) << endl;
   cout << "ptr math        :  (expected to diff) " << fmtio::cs("%x") % (p_long + 4) << endl;


   try
   {
     string tmp = fmtio::cs("%d %d") % 1;

     cout << "Error:  an exception that should have been thrown was not" << endl;

     cout << "The converted string is '" << tmp << "'" << endl;

     exit(1);

   }
   catch(fmtio::printableType::Exception const &e)
   {
     // do nothing
   }


}
catch(fmtio::printableType::Exception const &e)
{
  cout << "Attempt to convert a data type with the wrong format.\n"
       << "  expected type was:  " << e.expectedFormat_
       << "  found type was   :  " << e.foundType_
       << endl;
}
