//
// Copyright 2013, Lowell Boggs Jr.
//
// This file or directory, containing source code for a computer program,
// is Copyrighted by Lowell Boggs, Jr.  987 Regency Drive, Lewisville
// TX (USA), 75067.  You may use, copy, modify, and distribute this
// source file without charge or obligation so long as you agree to
// the following:
//
//  1.  You must indemnify Lowell Boggs against any and all financial
//      obligations caused by its use, misuse, function, or malfunction.
//      Further, you acknowledge that there is no warranty of any kind,
//      whatsoever.
//
//  2.  You agree not to attempt to patent any portion of this original
//      work -- though you may attempt to patent your own extensions to
//      it if you so choose.
//
//  3.  You keep this copyright notice with the file and all copies
//      of the file and do not change it anyway except language translation.
//
// You are responsible for enforcing your own compliance with these
// conditions and may not use this source file if you cannot agree to the
// above terms and conditions.

//@File
///   This file defines a test for the GdbController class.
///
///   The program defined here, expects the existing of a sister file, gdbTarget2.exe.
///   This file is a program that will debugged using GdbController and
///   the outputs produced from this program will be compared against
///   gdbcontroller_test2.expect
///


#ifndef _MSC_VER
#include <cxxtls/gdbcontroller.h>
using namespace cxxtls;
#endif


#include <iostream>

using namespace std;


int main(int argc, char **argv)
{
#ifdef _MSC_VER
  cout << "OOh!  No no no no no!  No can do big guy!  No way, Jose Cuervo" << endl;
#else

  CXXTLS_SET_PROGRAM_TRACE_LEVEL(cxxtls::TT_DEBUG);


  string mydir = argv[0];

  mydir = mydir.substr(0,  mydir.find_last_of('/') );

  if(mydir == argv[0])
  {
     mydir=".";  // in this case, the pull pathname was not passed to the executable.
  }

  string debuggee = mydir + "/gdbTarget2.exe";

  GdbController  gdb(true, debuggee + ".gdblog.log");

  gdb.setExecutable(debuggee);
  gdb.addBreakpoint("main");

  CXXTLS_LOG("ABOUT TO RUN TO MAIN");

  gdb.run();

  sleep(1);

  // we should be sitting at main now

  if(int(gdb.state()) != int(GdbController::stopped))
  {
     CXXTLS_DEBUG("Error:  in state " << gdb.stateName() << " but expected to be in " 
                  << "GdbController::stopped"
                 );
  }

  CXXTLS_LOG("Current Gdb state = " << gdb.stateName());

  CXXTLS_LOG( "ABOUT TO SEND TO TEXT TO TARGET STDIN");

  gdb.writeTargetStdin("hello\n");
  gdb.writeTargetStdin("goodbye\n");
  gdb.writeTargetStdin("quit\n");

  gdb.resume();

  sleep(2);

  CXXTLS_LOG( ">>>>>>>>>>>>>>>>>>>>>>>"  );
  CXXTLS_LOG( "Program Output:" );
  gdb.printAndDeleteTargetOutput();
  CXXTLS_LOG( ">>>>>>>>>>>>>>>>>>>>>>>"  );


#endif


}

