
//
// Copyright 2002, Lowell Boggs Jr.
//
// This file or directory, containing source code for a computer program,
// is Copyrighted by Lowell Boggs, Jr.  987 Regency Drive, Lewisville
// TX (USA), 75067.  You may use, copy, modify, and distribute this
// source file without charge or obligation so long as you agree to
// the following:
//
//  1.  You must indemnify Lowell Boggs against any and all financial
//      obligations caused by its use, misuse, function, or malfunction.
//      Further, you acknowledge that there is no warranty of any kind,
//      whatsoever.
//
//  2.  You agree not to attempt to patent any portion of this original
//      work -- though you may attempt to patent your own extensions to
//      it if you so choose.
//
//  3.  You keep this copyright notice with the file and all copies
//      of the file and do not change it anyway except language translation.
//
// You are responsible for enforcing your own compliance with these
// conditions and may not use this source file if you cannot agree to the
// above terms and conditions.



#include <iostream>
#include <iterator>
#include <algorithm>
#include <fstream>
#include <portable_strstream.h>

using namespace std;


typedef istreambuf_iterator<char>   source_iterator;
typedef ostreambuf_iterator<char>   destination_iterator;

int main()
{
   source_iterator       cur(cin);
   source_iterator       end;
   destination_iterator  out(cout);

   int count=0;

   while(cur != end)
   {
     ++count;
     *out++ = *cur++;
   }

   cout << "Count is " << count << endl;

   {
      std::ifstream exec_source("test_istreambuf.cxx");

      if(!exec_source)
      {
        cerr << "Error, can't open 'test_istreambuf.cxx'" << endl;
	exit(1);
	return 0;
      }

      std::istreambuf_iterator<char> f(exec_source);
      std::istreambuf_iterator<char> e;

      while(f != e)
      {
	cout << *f++;
      }

   }


   exit(0);

}
