#include <iostream>
#include <stdlib.h>
#include <cxxtls/skiprope.h>
#include <string>

typedef skiprope<std::string> Rope;

using namespace std;
using namespace cxxtls;

int main()
{
  Rope r;

  int i;

  int million = 1000 * 1000;
  int iterations = 1;

  for(i=0; i < million; ++i)
    r.push_back(std::string(i%100,'x'));

  r.visited_levels_ = 0;

  for(int j=0; j < iterations; ++j)
  for(i=0; i < million; ++i)
    if(r[i].size() != i%100)
    {
      cout << "Whoa, data error at " << i << endl << flush;
      exit(1);

    }

  cout << "A total of " << iterations * million << " lookups occurred" << endl;
  cout << endl;
  cout << "Visited levels is " << r.visited_levels_ << endl;
  cout.flush();

  cout << "Ok, press enter to page through the data";

  i = 0;

  while(getchar())
  {

     for(int j=0; j < 10; ++j)
     {
       std::string s = r[i++];
       cout << s << endl;
     }

     cout << " -- More?" << endl;

  }

}
